#include <stdio.h>
#include <qapp.h>
#include <qstring.h>
#include "util.h"
#include "qutil.h"
#include "MatrixView.h"
#include "EMData.h"

int initdone=0;
//Control *control;
QString dfdir;
MatrixView *mv;

int main( int argc, char **argv )
{
QFont *newdf;
QApplication a( argc, argv );
char *matrixfile=NULL,*imagefile=NULL;
int i,stereo=0;

appinit(argc,argv);

if (argc<2) error (ERR_EXIT,"glmatrix <points> [matrix=<filespec>] [images=<filespec>]");

for (i=2; i<argc; i++) {
	if (strncmp(argv[i],"matrix=",7)==0) matrixfile=&argv[i][7];
	else if (strncmp(argv[i],"stereo",6)==0) stereo=1;
	else if (strncmp(argv[i],"images=",7)==0) imagefile=&argv[i][7];
	else { printf("Unknown parameter '%s'\n",argv[i]); exit(1); }
}

printf("l\tLines connecting same altitude\np\tplanes connecting altitude\nt\tasymmetric triangle\n\
i\timages\nc\tcycle selected\n+\tincr. altitude\n-\tdecr altitude\n");

printf("Matrixfile = %s\nImagefile = %s\n",matrixfile,imagefile);

FILE *in = fopen(argv[1],"r");
if (!in) error(ERR_EXIT,"Cannot open points file");
int n=0;
char s[256];
while (fgets(s,255,in)) if (s[0]!='#') n++;
printf("%d points\n",n);
rewind(in);
float *data = (float *)malloc(n*6*sizeof(float));
for (i=0; i<n; i++) {
	fgets(s,255,in);
	if (s[0]=='#') {i--; continue; }
	data[i*6+4]=0;
	data[i*6+5]=0;	
	sscanf(s," %f %f %f %f %f %f",data+i*6,data+i*6+2,data+i*6+1,data+i*6+3,data+i*6+4,data+i*6+5);
}
fclose(in);

float *mx = NULL;
EMData mxd;
if (matrixfile) {
	mxd.readImage(matrixfile,0);
	if (mxd.ySize()!=n) error(ERR_EXIT,"matrix size doesn't match point file size");
	mx=mxd.getDataRO();
}

/*
 && (in=fopen(matrixfile,"r"))) {
	int nmx,swap=0;
	fread(&nmx,sizeof(int),1,in);
	if (nmx<0 ||nmx>100000) { swap=1; swapint((char *)&nmx,1); } 
	if (nmx!=n) { printf("Matrix point size mismatch %d != %d\n",nmx,n); exit(1); }
	mx = (float *)malloc(n*n*sizeof(float));
	for (i=0; i<n; i++) {
		fread(&nmx,sizeof(int),1,in);
		if (swap) swapint((char *)&nmx,1);
		fread(mx+n*nmx,sizeof(float),n,in);
		if (swap) swapint((char *)(mx+n*nmx),n);
	}
	fclose(in);
	printf("Matrix read complete\n");
}
if (matrixfile && !in) error(ERR_WARN,"Matrix file read failed");
*/

//EMQInit(&a);

if (getenv("PWD")) dfdir=getenv("PWD"); else dfdir="/";

if (stereo) {     
	QGLFormat f;
    f.setStereo( TRUE );
	mv=new MatrixView(f);
}
else mv=new MatrixView(QGLFormat());
a.setMainWidget(mv);
mv->resize(650,650);
mv->show();
mv->setPoints(n,data);
mv->setImageFile(imagefile);
if (mx) mv->setMatrix(mx);
initdone=1;

//control=new Control(NULL,"Name");
//a.setMainWidget(control);
//control->show();
//initdone=1;
return a.exec();
}
