#include <stdio.h>

class EMVtk {
public:
    EMVtk(const char* filename);
    EMVtk(FILE* in);
    ~EMVtk();
    
    int init();
    int read_data(float** p_data);
    int get_nx() const { return nx; }
    int get_ny() const { return ny; }
    int get_nz() const { return nz; }
private:
    const char* fname;
    FILE* in;
    char title[256];
    int type;
    int nx;
    int ny;
    int nz;
    float originx;
    float originy;
    float originz;
    float spacingx;
    float spacingy;
    float spacingz;
    
    enum VtkType { VTK_ASCII, VTK_BINARY };
};
