#include "InspPlot.h"
#include "InspPlotGen.h"
#include "InspPlotDset.h"
#include "LSPlotInsp.h"

#define Inherited InspPlotData

InspPlot::InspPlot(QWidget* parent,const char* name):Inherited( parent, name ) {
InspPlotGen *i0;
InspPlotDset *i2;
LSPlotInsp *i1;

insp[0]=i0=new InspPlotGen();
insp[2]=i2=new InspPlotDset();
insp[1]=i1=new LSPlotInsp();

stack->addWidget(i0,0);
stack->addWidget(i1,1);
stack->addWidget(i2,2);

ci=0;
target2=NULL;

stack->setFrameStyle( QFrame::Panel | QFrame::Sunken );
}


InspPlot::~InspPlot()
{
}

void InspPlot::refresh() {
DataSet *ds;

plotlist->clear();
for (int i=0; i<target->nPlots(); i++) {
	ds=target->plotAt(i)->getData();
	plotlist->insertItem(ds->title);
}

}

void InspPlot::newPlotTab(int n) { 
if (!target) return;
	
if (n<0 || n>2) return;
ci=n;

insp[n]->setTarget(target2);

stack->raiseWidget(n);
}

void InspPlot::newLegend(bool b) { 
	if (!target) return;
	if (b) target->setFlags(D2_OPT_LEGEND);
	else target->resetFlags(D2_OPT_LEGEND);
	target->update();
}

void InspPlot::newPlotList(int v) { 
	if (!target) return; 
	plotname->setText(plotlist->text(v));
	target2=target->plotAt(v);
	insp[ci]->setTarget(target2);
}

void InspPlot::newPlotName() { 
	if (!target) return;
	int n=plotlist->currentItem();
	plotlist->changeItem(plotname->text(),n);
	DataSet *ds=target->plotAt(n)->getData();
	ds->title=plotname->text();
}
